% *******************************************************
%	disparray.m
% *******************************************************
%	Display an array of size on ncol columns with text
% *******************************************************
	function disparray ( array, size, ncol, text )
% *******************************************************
for iii=1:ncol:size
	istart = iii;
	istop = iii+ncol-1;
	if istop > size, istop = size; end
	dispnum ( array(istart:istop), [text,'(',num2str(istart),':',num2str(istop),')'] );
end
% *******************************************************
% end disparray.m
% *******************************************************
