%
function tf()
p(1) = subplot('position', [0.02 0.52 0.46 0.46]);
p(2) = subplot('position', [0.02 0.02 0.46 0.46]);
p(3) = subplot('position', [0.52 0.52 0.46 0.46]);
p(4) = subplot('position', [0.52 0.02 0.46 0.46]);

npoints = 4;
nvars = 2;
nobjectives = 2;

points = rand(npoints, nvars) * 100 - 50;
dominated = zeros(npoints, 1);
neighbours = ones(npoints, 1);
new = ones(npoints, 1);
new_obj = ones(npoints, 1);
dying = ones(npoints, 1);
bred = ones(npoints, 1);
parents = ones(npoints, 1);
failed_iterations = 0;

obj = ones(npoints,2);
a =[-0.581479779325832 -0.37426947600907 -0.303276079487954 -0.14570131437332;0.497803431016739 -0.703289738596115 0.181808789002371 -0.131281024874781;670.06987468506 833.85592099626 1522.33128616535 319.98110459724;4586.74138838826 -2208.70760638392 5145.89940153151 9892.36844745545;0.771130801881329 0.744169954651894 0.716402824257725 -0.5621465124564];


for i = 1:100
		points = 100*rand(npoints,2) - 50;
	draw(points, obj, parents, dying, bred, new, new_obj, a, p)
end


	function draw(points, obj, parents, dying, bred, new, new_obj, a, p)
	if (sum(dying) > 0 | bred)
		pmin = min(points);
		pmax = max(points);
		
		int = pmax - pmin;
		pmin = pmin - 0.05 .* int;
		pmax = pmax + 0.05 .* int;
		
		x1 = linspace(pmin(1), pmax(1), 30);
		x2 = linspace(pmin(2), pmax(2), 30);
		[x1, x2] = meshgrid(x1, x2);
		x = cat(3, x1, x2);
		y = x;	%	objective(x, a);

		for j = 1:2
			subplot(p(j));
			hold off;
			surf(x(:, :, 1), x(:, :, 2), y(:, :, j));
			the_axes = axis;
			min_z = the_axes(5);
			hold on;
			
			% Plot points
			plot3(points(:, 1), points(:, 2), obj(:, j), 'b+');
			plot3(points(:, 1), points(:, 2), ones(size(points(:, 1))) * min_z, 'b+');

			% Plot dying points
			if (sum(dying) > 0)
				plot3(points(dying, 1), points(dying, 2), obj(dying, j), 'ro');
			 	plot3(points(dying, 1), points(dying, 2), min_z * ones(sum(dying), 1), 'ro');
			end

			% Plot parents and child
			if (bred)
				% Parents
				plot3(points(parents, 1), points(parents, 2), obj(parents, j), 'g+');
				plot3(points(parents, 1), points(parents, 2), min_z * ones(size(parents)), 'g+');
				plot3(points(parents, 1), points(parents, 2), min_z * ones(size(parents)), 'g-');

				% Child
				plot3(new(1), new(2), new_obj(j), 'g*');
				plot3(new(1), new(2), min_z, 'g*');
			end
		end


		subplot(p(3));
		hold off
		plot(obj(:, 1), obj(:, 2), 'b+');
		hold on
		if (sum(dying) > 0)
			plot(obj(dying, 1), obj(dying, 2), 'ro');
		end
		if (bred)
			plot(obj(parents, 1), obj(parents, 2), 'g+');
			plot(obj(parents, 1), obj(parents, 2), 'g-');
			plot(new_obj(1), new_obj(2), 'g*');
		end

		subplot(p(4));
		hold off
		plot(points(:, 1), points(:, 2), 'b+');
		hold on
		if (sum(dying) > 0)
			plot(points(dying, 1), points(dying, 2), 'ro');
		end
		if (bred)
			plot(points(parents, 1), points(parents, 2), 'g+');
			plot(points(parents, 1), points(parents, 2), 'g-');
			plot(new(1), new(2), 'g*');
		end
	
		pause(0.01)
%		pause
	end
