% *******************************************************
%	IHRS design and optimization using Genetic Algorithms 
%	Interface to the GA library.
% *******************************************************
%	02.02.2000 - last : 03.02.00 by OW|BR
%	IntermediateConstraints.m
% *******************************************************

if helppri==1, help IntermediateConstraints; end
pausetext = 'Press any key ...';

%	if interpri > 0
	disp(' ');
	disp ( ' IntermediateConstraints ! ' );
	disp(' ');
	disp ( [ ' Constraints on k_max(p), p=  1:P for  all Streams : k_max = ', num2str(k_max) ] );
	disp ( [ ' Constraints on k_min(p), p=  1:P for  all Streams : k_min = ', num2str(k_min) ] );
	disp ( [ ' Constraints on k_max(p), p=  1:I for  Hot Streams : k_max = ', num2str(k_max(1:I)  ) ] );
	disp ( [ ' Constraints on k_min(p), p=I+1:P for Cold Streams : k_min = ', num2str(k_min(I+1:P)) ] );
	disp ( [ '                         For  Hot Streams if Tk < HotStream.T_S  = ', num2str([Stream(1:I).T_S])  ] );
	disp ( [ '                         For Cold Streams if Tk > ColdStream.T_S = ', num2str([Stream(I+1:P).T_S]) ] );
	disp ( [ ' Storage temperatures always in increasing order :   Tk   = ', num2str(Tk) ] );
	disp(' ');
%	end

IV_XL = 0;
k_max(1:I) = k_min(1:I);		% for hot streams, k_min = 1		%PK100200
for p = 1:I
	for k = 2:K					% k_max(i)=0 or 1 can be found (in both cases no feasible match with Sss1-2 %PK100200
		if T_Sp(p) > Tk(k)
			k_max(p) = k;
			disp ( [ 'k, i -- k_max - T_S, Tk(k)  =  ', num2str(k), ' , ', num2str(p),...
				' -- ', num2str(k_max(p)), ' - ', num2str(T_Sp(p)), ' ,  ', num2str(Tk(k)) ] ) ;
		end
   end
   if k_max(p) >= 2	%	i.e if k_max - 1 - k_min >= 0 with k_min=1
      IV_XL = IV_XL + k_max(p) - 1;
   end
end
k_min(I+1:P) = k_max(I+1:P);
for p = I+1:P
	for k = K-1:-1:1				% k_min(j)=K+1 or K can be found (in both cases no feasible match with SssK-K-1 %PK100200
		if T_Sp(p) < Tk(k) 
			k_min(p) = k;
			disp ( [ 'k, j -- k_min - T_S, Tk(k)  =  ', num2str(k), ' , ', num2str(p),...
				' -- ', num2str(k_min(p)), ' - ', num2str(T_Sp(p)), ' ,  ', num2str(Tk(k)) ] ) ;
		end
	end
   if k_min(p) <= K-1	%	i.e if k_max - k_min >= 1 with k_max=K
      IV_XL = IV_XL + K - k_min(p);
   end
end
%	if interpri > 0
	disp(' ');
	disp ( [ ' Constraints on k_max(p), p=  1:I for  Hot Streams : k_max = ', num2str(k_max(1:I)  ) ] );
	disp ( [ ' Constraints on k_min(p), p=I+1:P for Cold Streams : k_min = ', num2str(k_min(I+1:P)) ] );
	disp ( [ ' Constraints on k_max(p), p=  1:P for  all Streams : k_max = ', num2str(k_max) ] );
	disp ( [ ' Constraints on k_min(p), p=  1:P for  all Streams : k_min = ', num2str(k_min) ] );
%	end

% disp('  ');
disp ( ' End of Program --- IntermediateConstraints !' );
% ***************************************************