%********************************************
%	ed.m
%********************************************
%	Run file for optimize.dll mex file
%********************************************
	global xx;
	global PrintTrace;
	global TBCs_min
	global HR_of_TBCs_min
   xx = 0;
%********************************************
! move optimize_1.log optimize_1prev.log
diary optimize_1.log

disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
disp ('  Starting ed.m Matlab procedure for the optimization with Struggle  ');
disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
help red
disp ( ['          ',datestr(now)] );
disp ('@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@');
disp ('');

PTrace = Ptrace_mex;
PnPlot = NPLOTtot;

nvar = length(X_SX);	%	nvar = IV_SX;
xopt = 0.9 * ones(1,nvar);
xopt(K+1:K+P) = 1;	%	P integer variables	
xwei = ones(1,nvar);
xmin = X_SX_min;
xmax = X_SX_max;

%xopt(1) = 0;
%X_SX(1) = 0.1162329448;
%xopt(2) = 0;
%X_SX(2) = 0.3448481504;
%xopt(3) = 0;
%X_SX(3) = 0.1490448682;
%xopt(4) = 0;
%X_SX(4) = 0.4290599825;

xval = X_SX;
npop = I_SX;
ngen = G_SX;
pmut = p_m_SX;
pcro = p_c_SX;
nwei = length(Dweight);		% length(X) = max(size(X));		% new K523
Dwei = Dweight;


% structure that defines general user data
UserData.inXsize = nvar;
UserData.inXopt = xopt;
UserData.inXwei = xwei;
UserData.inXmin = xmin;
UserData.inXmax = xmax;
UserData.inXval = xval;
UserData.inDsize = nwei;
UserData.inDwei = Dwei

% structure that defines the parameters
Parameters.inN_POP = npop;
Parameters.inN_GEN = ngen;
Parameters.inP_MUT = pmut;
Parameters.inP_CRO = pcro

% structure that defines the control data
Control.PnPlot = PnPlot;
Control.PTrace = PTrace

% initialisation of output variables
N_OF_side = 5;
OF_side   = ones(1,N_OF_side);

out1 = [ 191,292,393,494 ];
out2 = -1;
out3 = 999;
out4 = [888];
tic;
% BestGenome : same structure as UserData
% [BestGenome, out3, out4] = optimize ( UserData,Parameters,Control );	% call DLL % new K718
[BestGenome, OF_side, N_OF_side] = optimize ( UserData,Parameters,Control );	% call DLL % new K927
% ========================================================================

disp(' Back after call to optimize.dll. Return to Red.m !!!!! ');

disp(' ');
disparray ( out1, out2, 5, 'BestGenome' );
n_improvements 

%dispnum ( N_OF_side,  'Number of side functions', '  N_OF_side' );
dispnum ( OF_side(1), 'best objective function ', '  OF_side(1) = TBCs_min' );
%dispnum ( OF_side(1), 'cost function   number 1', '  OF_side(1) = Cost 1' );
%dispnum ( OF_side(2), 'cost function   number 2', '  OF_side(2) = Cost 2' );
%dispnum ( OF_side(3), 'cost function   number 3', '  OF_side(3) = Cost 3' );
%dispnum ( OF_side(4), 'best objective function ', '  OF_side(4) = TBCs_min' );
%dispnum ( OF_side(5), 'heat recovery at this OF', '  OF_side(5) = HR_of_TBCs_min' );

disp(' ');

X_SX = BestGenome.inXval;	% recovers the best genome for a detailled evaluation of the best solution through "OF_Best" below 
disparray ( BestGenome.inXval, BestGenome.inXsize, 5, 'BestGenome' );

disp(' ');
telapsed=toc;
dispnum ( telapsed, 'time elapsed in Red.m', 'sec' );

OF_Best;	% Recalculate results for the best individual (independent variables recovered in X_SX at the end of Red.m) 

bad_offspring
diary off					%	pour fermer le fichier log
clear optimize					%	pour librer le handle du fichier optimize.dll
save optimize

%********************************************
%	end of ed.m
%********************************************

